#include "SOFT_SPI.h"

// ソフトウエアＳＰＩ通信:MODE0 MSBFARST
SOFT_SPI SSPI ;

void SOFT_SPI::begin(int CLK,int MISO,int MOSI) {
  clk = CLK ;
  miso = MISO ;
  mosi = MOSI ;
  pinMode(mosi, OUTPUT);
  pinMode(miso, INPUT);
  pinMode(clk , OUTPUT);
}

uint8_t SOFT_SPI::transfer(uint8_t writeData,bool flagRead) {

  uint8_t bval = 0;
  uint8_t readData = 0;
  for (uint8_t bit = 0x80; bit; bit >>= 1) {
    digitalWrite(mosi, writeData & bit);

    bval = digitalRead(miso);
    readData <<= 1;
    readData |= bval;

    digitalWrite(clk, HIGH);
    digitalWrite(clk, LOW);
  }
 
  return readData ;
}

void SOFT_SPI::transfer(uint8_t writeData[],int WriteDataLen) {
  for (int d = 0; d < WriteDataLen; d++) {
    writeData[d] = transfer(writeData[d]) ;
  }
}
